#!/usr/bin/env python3 -*- coding: utf-8

import serial
import os
import sys
from time import sleep

#__________________________________________________

serial_port = "/dev/ttyACM1"
count_timeout = 3

def send_msg():
    success = 0
    count = 0

    if os.path.exists(serial_port):
        print("\nFound serial port",serial_port,"!\n")
        #sleep(1)

        #with serial.Serial('/dev/ttyACM1', 9600, timeout=1) as arduino:
        with serial.Serial(serial_port, 9600, timeout=1) as arduino:
            try:
                sleep(0.1)

                if arduino.isOpen():
                    arduino.reset_input_buffer()
                    print(f"writing '{msg}' to gun..")
                    arduino.write(msg.encode())
                    sleep(0.1)

                    if int(wait) > 0:
                        print("waiting for response..")
                        while count < count_timeout:
                            try:
                                if arduino.inWaiting()==0:
                                    sleep(1)
                                    count = count+1
                                elif arduino.inWaiting()>0:
                                    while arduino.inWaiting()>0:
                                        line = arduino.readline().decode('utf-8').strip()
                                        print("\nReceived: \x27"+line+"\x27\n\n")
                                        sleep(0.1)
                                        arduino.flushInput()
                                        success = 1
                                        os._exit(1)
                                    break
                            except serial.SerialException as se:
                                print("Serial port error:",se)
                                break
                    arduino.close()

            except Exception as e:
                print(f"Error opening Arduino:",e)

            except KeyboardInterrupt:
                print("KeyboardInterrupt has been caught.")
                arduino.close()
                os._exit(1)
    else:
        print(f"Waiting for {serial_port}...")
        sleep(5)


#--------------------------------------------------

count = 0
msg = ''
wait = 0
force = 0
success = 0

arg_len = (len(sys.argv)-1)
print("ARGS:",arg_len,sys.argv)

if arg_len > 0:
    try:
        msg = sys.argv[1]
        if arg_len > 1:
            if sys.argv[2].strip().isdigit():
                wait = sys.argv[2].strip()
        if arg_len > 2:
            if sys.argv[3].strip().isdigit():
                force = sys.argv[3].strip()

        send_msg()

        if (int(force) > 0) and (success < 1):
            while success < 1:
                send_msg()
        os._exit(1)

    except Exception as e:
        print(f"No args provided..")


#while True:
#    loop()
#    #sleep(1)

#fifo.close()
sys.exit()
