#!/bin/bash

#log_path='/home/pi/ADMIN/.log/autostart.log'
log_path='/boot/boot.log'
[ ! -f "$log_path" ] && touch "$log_path"
sudo chmod 775 "$log_path"
sleep 1

#exec > >(sudo tee "$log_path" 2>&1)
exec > $log_path 2>&1

include_file='/home/pi/ADMIN/.sys/include.sh'
[ -f $include_file ] && source $include_file
include

Main() {
   datestring=$(date | cut -c -20)
   echo -e "\nA U T O S T A R T   L O G:"
   echo -e "( $datestring )\n\nlogfile: $log_path"

   # FILE OPERATIONS
   sudo cp -f "$HOMEDIR/ADMIN/.sys/.states.default" "$HOMEDIR/ADMIN/.sys/.states"
   sudo cp -f "$HOMEDIR/CAFCA/data/.states.default" "$HOMEDIR/CAFCA/data/.states"
   sudo mkfifo /tmp/pyserial.fifo && sudo chmod 777 /tmp/pyserial.fifo

   # DRIVER INITS
   #amixer -c 1 set "Headphone" 100
   #tvservice -c "NTSC 4:3 P"; sudo python3 /home/pi/tweakvec/tweakvec.py --preset PAL60; fbset -depth 8; fbset -depth 32; tvservice -s
   #fbset -xres 512 -yres 288

   # INPUTS
   #bash /home/pi/menu/joy2key-launch.sh & # &>/dev/null &
   #sh /home/pi/wiimote.sh &
   #sudo nohup thd --triggers /etc/triggerhappy/triggers.d/teensy.conf --socket /var/run/thd.socket --user root --deviceglob /dev/input/event* &
   sudo thd --triggers /etc/triggerhappy/triggers.d/teensy.conf --socket /var/run/thd.socket --user root --daemon --deviceglob /dev/input/by-id/usb-Teensyduino_Serial_Keyboard_Mouse_Joystick_1008140-if02-event-kbd

   # SCRIPTS
   sudo python3 "$HOMEDIR/ADMIN/CMD/PYTHON/SERIAL/serial_daemon.py" & #|& sudo tee /home/pi/ADMIN/.log/serial_daemon.log 2>&1 &
   sleep 5
   printf "BOOTED 1" > /tmp/pyserial.fifo

   #sudo bash /home/pi/ADMIN/BOOT.sh &
   #python3 /home/pi/menu/admin/bootSerial.py &
   #bash /home/pi/menu/admin/startup-sound/randSound.sh &

   #asciiview /home/pi/_files/img/arcade-poster-invert.png &
   #ascii_pid=$!
   #sleep 2
   #sudo kill -9 "$ascii_pid"

   #compile_logs

   # BOOT MENUS
   #bash /home/pi/menu/_boot.sh
   #bash /home/pi/menu/dialog_mnu.sh
   #bash /home/pi/menu/list-menu.sh

   emulationstation #auto
   #emulationstation --screenoffset 32 0 #auto

}

get_sysinfo() {
  serial_num=$(cat /proc/cpuinfo | grep Serial | cut -d ' ' -f 2 | cut -c 9- );echo "$serial_num"
}


compile_logs() {
  echo -e "\n____________________________\n"
  echo -e "LOG DUMP:\n"

  echo -e "  -DMESG:\n"
  #dmesg | awk -F']' '{print $2}'
  while read -r line; do
    [ $(echo $line | grep -c '^$') -lt 1 ] && echo $line | sed 's/:/:\t/'
  done< <(dmesg | awk -F']' '{print $2}' | awk '{$1=$1;print}')

}

Main

#while :;do
#  sleep 1
#done
#_____________________________________


